/* -*- mode: c++ -*- */

// *************
// Simulation
// *************


// *************
// Visualization
// *************
__kernel
void visualizationClear(const int width, const int height, __global float4* visualizationBuffer){
  int2 id = (int2)(get_global_id(0), get_global_id(1));

  if( id.x < width && id.y < height){
    visualizationBuffer[id.x + id.y * width] = (float4)(0.0f);
  }
}


int2 sampl(int2 coord, int width, int height)
{
	int x = coord.x;
	x = min(width - 1, x);
	x = max(0, x);
	int y = coord.y;
	y = min(height - 1, y);
	y = max(0, y);
	return (int2)(x,y);
}

__constant float r = 0.01;

__kernel
void visualization(const int width, const int height, __global float4* visualizationBuffer, __global float4* particleBuffer)
{
	int id = get_global_id(0);
	float4 posdir = particleBuffer[id];
	int w = (float) width * r;
	for(int i = -w; i <= w; ++i)
	for(int j = -w; j <= w; ++j)
	{
	 int2 coord = sampl((int2)(posdir.x * (width -1) + i, posdir.y * (height -1) + j), width , height);

	 visualizationBuffer[coord.x + coord.y * width] =
		(float4) (1, 1, 1, 1);
	}

}

//TODO create simulation kernel